//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%41486FA2017A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%41486FA2017A.cm

//## begin module%41486FA2017A.cp preserve=no
//## end module%41486FA2017A.cp

//## Module: PlotDem%41486FA2017A; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotDem.cxx

//## begin module%41486FA2017A.additionalIncludes preserve=no
//## end module%41486FA2017A.additionalIncludes

//## begin module%41486FA2017A.includes preserve=yes
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>
#include <XSPlot/Plot/PlotGroupCreatorClasses.h>
//## end module%41486FA2017A.includes

// PlotDem
#include <XSPlot/Commands/PlotDem.h>
//## begin module%41486FA2017A.declarations preserve=no
//## end module%41486FA2017A.declarations

//## begin module%41486FA2017A.additionalDeclarations preserve=yes
//## end module%41486FA2017A.additionalDeclarations


// Class PlotDem 

PlotDem::PlotDem()
  //## begin PlotDem::PlotDem%41487028002D_const.hasinit preserve=no
  //## end PlotDem::PlotDem%41487028002D_const.hasinit
  //## begin PlotDem::PlotDem%41487028002D_const.initialization preserve=yes
  : PlotCommand("dem",new CreateDemPlotGroups())
  //## end PlotDem::PlotDem%41487028002D_const.initialization
{
  //## begin PlotDem::PlotDem%41487028002D_const.body preserve=yes
   isDataRequired(false);
   isActiveModelRequired(false);
   isDivisibleByArea(false);
   addCompLevel(0);
   isBackgroundApplicable(false);
   
   PlotAttributes styles;
   styles.symbolStyle = PlotStyle::CIRCLE;
   styles.lineStyle = PlotStyle::DASH;
   setStyleMap(PlotStyle::DATA, styles);
  //## end PlotDem::PlotDem%41487028002D_const.body
}


PlotDem::~PlotDem()
{
  //## begin PlotDem::~PlotDem%41487028002D_dest.body preserve=yes
  //## end PlotDem::~PlotDem%41487028002D_dest.body
}



//## Other Operations (implementation)
void PlotDem::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotDem::setRanges%4B4274D801F4.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
   xlow -= xlow/8.0;
   xhigh += xhigh/8.0;
   
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   // Always plot X scale as log
   rangeVals.xScaleType = PlotStyle::LOG;
   rangeVals.yScaleType = settings.yLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
   rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
  //## end PlotDem::setRanges%4B4274D801F4.body
}

void PlotDem::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotDem::makeLabels%4B4274EB0178.body preserve=yes
   labels.x = settings.lookupLabelName("x:dem");
   labels.y = settings.lookupLabelName("y:dem");
  //## end PlotDem::makeLabels%4B4274EB0178.body
}

// Additional Declarations
  //## begin PlotDem%41487028002D.declarations preserve=yes
  //## end PlotDem%41487028002D.declarations

//## begin module%41486FA2017A.epilog preserve=yes
//## end module%41486FA2017A.epilog
